
irqInit:
        di
        ld    hl, irqCodeBegin
        ld    de, irqRoutine
        ld    bc, irqCodeEnd - irqCodeBegin
        call  memcpy_I
        ld    hl, 1d00h
        ld    de, 1d01h
        ld    bc, 0100h
        ld    (hl), high irqRoutine
        call  memcpy_I
        im    2
        ld    a, 1dh
        ld    i, a
        ld    a, (imgData + 3)
        and   3
        ld    e, a
        xor   (iy + 3)
        and   60h
        bit   1, e
        jr    z, .l1
        and   40h
.l1:    ld    hl, 10000h - 4
        or    a
        jr    z, .l4                    ; -mode < 10, -palres 0?
        cp    40h
        jr    z, .l3                    ; -mode >= 10, -palres 0?
        cp    20h
        jr    nz, .l2                   ; -mode >= 10, -palres 1?
        xor   a                         ; -mode < 10, -palres 1
        defb  0c2h                      ; = JP NZ, nnnn
.l2:    ld    a, 17h                    ; = RLA
        ld    (irqRoutine.l10), a
        inc   e
        sla   e
        ld    d, 0
        add   hl, de
        ld    (irqRoutine.l4 + 1), hl
        ld    hl, imgData + 16
        ld    (irqRoutine.l6 + 1), hl
        ld    (irqRoutine.l12 + 1), hl
        ld    (irqRoutine.l14 + 1), hl
        add   hl, de
        ld    (irqRoutine.l1 + 1), hl
        ld    (irqRoutine.l11 + 1), hl
        ld    (irqRoutine.l13 + 1), hl
    if NO_INTERLACE == 0
        bit   6, (iy + 3)
        jr    z, .l5
        ld    a, e
        ld    hl, (imgData + 10)
        srl   h
        rr    l
        call  mult_HL_A
        ld    bc, imgData + 16
        add   hl, bc
        ld    (irqRoutine.l12 + 1), hl
        add   hl, de
        ld    (irqRoutine.l13 + 1), hl
    endif
        jr    .l5
.l3:    ld    a, 17h                    ; = RLA
.l4:    ld    (irqRoutine.l10), a
        ld    (irqRoutine.l4 + 1), hl
        ld    hl, imgData + 4
        ld    (irqRoutine.l1 + 1), hl
        ld    (irqRoutine.l6 + 1), hl
        ld    (irqRoutine.l11 + 1), hl
        ld    (irqRoutine.l12 + 1), hl
        ld    (irqRoutine.l13 + 1), hl
        ld    (irqRoutine.l14 + 1), hl
.l5:    ld    hl, (imgData + 10)
    if NO_INTERLACE == 0
        bit   6, (iy + 3)
        jr    z, .l6
        srl   h
        rr    l
    endif
.l6:    ld    (irqRoutine.l2 + 1), hl
        xor   a
        ld    (irqRoutine.l8 + 1), a
        ld    (irqRoutine.l9 + 1), a
        ld    hl, crtcRegisters_08_0F
        ld    bc, 0871h
        ld    a, 8
.l7:    out   (70h), a
        inc   a
        outi
        jr    nz, .l7
        ld    a, 0afh
        out   (04h), a
        ld    a, 1fh
        out   (05h), a
        out   (07h), a
        ei
        ret

irqCodeBegin:

        phase 1e1eh

irqRoutine:                             ; 19 (IM 2)
        ex    af, af'                   ; 23
        nop                             ; 27
        push  bc                        ; 38
        push  de                        ; 49
        push  hl                        ; 60
        ld    (.l7 + 1), sp             ; 80
.l1:    ld    sp, imgData + 16 + 4      ; * 90
.l2:    ld    de, 0                     ; * 100
.l3:    pop   bc                        ; 110
        pop   hl                        ; 120
        ld    a, c                      ; 124
        ld    c, 61h                    ; 131
        out   (60h), a                  ; 142
        out   (c), b                    ; 154
        inc   c                         ; 158
        out   (c), l                    ; 170
        inc   c                         ; 174
        out   (c), h                    ; 186
.l4:    ld    hl, 0                     ; * 196
        add   hl, sp                    ; 207
        ld    sp, hl                    ; 213
        nop                             ; 217
        ld    b, 3                      ; 224
.l5:    inc   hl                        ; 230, 249, 268
        djnz  .l5                       ; 243, 262, 276
        dec   de                        ; 282
        ld    a, e                      ; 286
        or    d                         ; 290
        jp    nz, .l3                   ; 300
.l6:    ld    sp, imgData + 16          ; * 310
        pop   de                        ; 320
        pop   hl                        ; 330
        out   (c), h                    ; 342
        dec   c                         ; 346
        out   (c), l                    ; 358
        dec   c                         ; 362
        out   (c), d                    ; 374
        dec   c                         ; 378
        out   (c), e                    ; 390
.l7:    ld    sp, 0000h                 ; *
        out   (07h), a
.l8:    ld    a, 00h                    ; *
        cpl
        ld    (.l8 + 1), a
.l9:    xor   00h                       ; *
.l10:   nop                             ; * 00h (NOP) / 17h (RLA)
        jr    c, .l13
.l11:   ld    hl, imgData + 16 + 4      ; *
.l12:   ld    de, imgData + 16          ; *
        ld    a, 00h
        jp    .l15
.l13:   ld    hl, imgData + 16 + 4      ; *
.l14:   ld    de, imgData + 16          ; *
        ld    a, 10h
.l15:   ld    (.l1 + 1), hl
        ld    (.l6 + 1), de
        out   (0fh), a
        pop   hl
        pop   de
        pop   bc
        ex    af, af'
        ei
        ret

        dephase

irqCodeEnd:

irqCleanup:
        di
        im    1
        ld    bc, 0a70h
        ld    a, 03h
        out   (c), b
        out   (71h), a
        inc   b
        out   (c), b
        out   (71h), a
        ld    b, 0fh
        xor   a
        out   (c), b
        out   (71h), a
        out   (07h), a
        out   (0fh), a
        ld    a, (0003h)
        out   (02h), a
        ret

crtcRegisters_08_0F:
        defb  00h, 03h, 00h, 00h, 00h, 00h, 00h, 01h

