        org     6639
        db      0FH,0AH,0,0DDH
        db      " USR"
        db      96H,"6659"
        db      95H,0FFH,0,0,0,0,0      ; 20 byte-os fej
;       org     1a03h

NO_INTERLACE    equ     0

    macro mops n
        rst   30h
        defb  n
    endm

        jp    main

        assert  ($ & 00ffh) < 0b0h

    module  DecompressM0
        include "decompress_m0.s"
    endmod
        include "rle.s"

paletteSize:
        ld    hl, 0
        ld    a, (imgData + 3)
        and   23h
        xor   20h
        cp    2
        ret   nc
        rla
        inc   a
        ld    hl, (imgData + 10)

; HL = HL * A

mult_HL_A:
        ld    c, l
        ld    b, h
        scf
        rla
        jr    c, .l2
        ld    hl, 0000h
.l1:    add   hl, hl
.l2:    add   a, a
        jr    nc, .l1
        ret   z
        add   hl, hl
        add   hl, bc
        jp    .l2

        assert  $ <= 1c80h
        ds      2000h - $, 00h

    module DecompressM2
        include "decompress_m2_new.s"
    endmod

main:
        di
        ld    sp, 2000h
        xor   a
        out   (00h), a
        out   (0fh), a
    if NO_INTERLACE == 0
        ld    a, 70h
    else
        ld    a, 50h
    endif
        ld    (0003h), a
        out   (02h), a
        ei
        ld    de, fileName
        mops  211                       ; CAS_OPEN
        or    a
        jr    nz, .errNZ
        ld    de, imgData
    if NO_INTERLACE == 0
        ld    bc, 0c000h - imgData
    else
        ld    bc, 8000h - imgData
    endif
        mops  210                       ; CAS_BKIN
        cp    0ech                      ; EOF
        jr    nz, .errNZ
    if NO_INTERLACE == 0
        ld    hl, 0c000h - (imgData + 16)
    else
        ld    hl, 8000h - (imgData + 16)
    endif
        xor   a
        sbc   hl, bc
.errC:  jp    c, hiba
        or    h
        jr    z, .errZ
        ld    (imgData + 14), hl
        mops  212                       ; CAS_CLOSE
        ld    hl, imgData
        push  hl
        pop   iy
        ld    a, (hl)
        inc   hl
        cp    'K'
        jr    nz, .errNZ
        ld    a, (hl)
        inc   hl
        cp    'E'
        jr    nz, .errNZ
        ld    a, (hl)
        inc   hl
        cp    'P'
        jr    nz, .errNZ
        ld    a, (hl)
        and   3
        cp    3
.errZ:  jp    z, hiba
        xor   (hl)
    if NO_INTERLACE != 0
        bit   6, a                      ; b6 = interlace
        jr    nz, .errNZ
    endif
        cpl
        and   18h                       ; 18h = epcompress -m3, 1Ch = Zlib
        jr    z, .errZ
        ld    a, (hl)
        or    a
        call  z, formatImg
        ld    a, (imgData + 3)
        cpl
        and   3
        ld    b, a
        di
        xor   83h
        out   (06h), a
        ld    de, 0
        ld    hl, (imgData + 8)         ; W
.l1:    srl   h
        rr    l
        adc   hl, de
        djnz  .l1
        ld    a, h
        or    a
.errNZ: jp    nz, hiba                  ; W >= 256?
        or    l
        jr    z, .errZ                  ; W < 1?
        ld    ixl, a
        add   a, 255 - 84
        jr    c, .errC                  ; W > 84?
        ld    hl, (imgData + 10)        ; H
    if NO_INTERLACE == 0
        ld    a, (imgData + 3)
        ld    b, 1
        rla
        rla
        rl    b
    else
        ld    b, 2
    endif
.l2:    srl   h
        rr    l
        adc   hl, de
        djnz  .l2
        ld    a, h
        or    a
        jr    nz, .errNZ                ; (H / 4) >= 256?
        or    l
        jr    z, .errZ                  ; (H / 4) < 1?
        ld    ixh, a
        cp    72 + 1
        jp    nc, hiba                  ; (H / 4) > 72?
        ld    l, a
        ld    a, ixl
        call  mult_HL_A
        dec   hl
        ld    a, 0f0h
        and   h
        jr    nz, .errNZ                ; > 16K?
        di
        ld    hl, imgData + 7
        ld    bc, 0464h
.l3:    dec   c
        outd
        jr    nz, .l3
        ld    a, (hl)
        and   14h
        call  nz, decompressImg
        ld    a, (imgData + 12)
        out   (00h), a
   if NO_INTERLACE == 0
        ld    a, 50h
        out   (02h), a
   endif
        call  paletteSize
        ld    bc, imgData + 16
        add   hl, bc
    if NO_INTERLACE == 0
        push  hl
        push  ix
    endif
        call  loadImg
    if NO_INTERLACE == 0
        pop   ix
        pop   de
        bit   6, (iy + 3)
        jr    z, .l4
        ld    a, 70h
        out   (02h), a
        ld    hl, (imgData + 10)
        srl   h
        rr    l
        ld    a, ixl
        call  mult_HL_A
        ld    c, l
        ld    b, h
        add   hl, de
        push  de
        call  memcpy_I
        pop   hl
        ld    a, 50h
        out   (02h), a
        ld    a, 04h
        out   (0fh), a
        call  loadImg
    endif
.l4:    call  irqInit
.l5:    ei
        halt
        xor   a
        out   (03h), a
        in    a, (58h)
        and   20h                       ; I'
        jp    z, hiba
        ld    a, 7
        out   (03h), a
        in    a, (58h)
        bit   3, a                      ; Esc
        jp    z, hiba
        bit   5, a                      ; Space
        jr    z, .l8
    if NO_INTERLACE == 0
        ld    a, 2
        out   (03h), a
        in    a, (58h)
        and   02h                       ; E
        jr    z, .l7
        ld    a, 3
        out   (03h), a
        in    a, (58h)
        cpl
        and   46h                       ; I, O, P
        jr    z, .l5
        bit   2, a                      ; O
        jr    nz, .l6
        and   02h                       ; I
        rra
        ld    bc, 0870h
        out   (c), b
        out   (71h), a
        jr    .l5
.l6:    scf
.l7:    sbc   a, a
        ld    (irqRoutine.l9 + 1), a
    endif
        jr    .l5
.l8:    call  irqCleanup
        ld    hl, fileName + 6
.l9:    inc   (hl)
        ld    a, (hl)
        cp    '9' + 1
        jp    c, main
        ld    (hl), '0'
        dec   hl
        jr    .l9

        include "irq.s"

; IXL = W
; IXH = H / 4
; HL = src
; DE = dst

loadImg:
        di
        ld    de, 8000h
        ld    bc, 0170h
        out   (c), b
        ld    a, ixl
        out   (71h), a
        inc   b
        out   (c), b
        add   a, 86
        rra
        out   (71h), a
        ld    b, 6
        out   (c), b
        ld    a, ixh
        out   (71h), a
        inc   b
        out   (c), b
        add   a, 73
        rra
        out   (71h), a
.l1:    ld    (.l4 + 1), de
        ld    c, ixl
        ld    b, 0
        ld    a, e
        or    0c0h
.l2:    inc   a
        jr    z, .l6
        ldi
.l3:    jp    pe, .l2
        ld    a, e
        add   a, 64
        jr    c, .l5
.l4:    ld    de, 0                     ; *
        ld    a, e
        add   a, 64
        ld    e, a
        jr    .l1
.l5:    ld    e, a
        dec   ixh
        jr    nz, .l1
        ret
.l6:    ldi
        push  bc
        ld    c, 0c0h
        ex    de, hl
        add   hl, bc
        ex    de, hl
        ld    a, c
        pop   bc
        jr    .l3

formatImg:
        ld    hl, (imgData + 14)
        ld    bc, 8
        add   hl, bc
        ld    (imgData + 14), hl
        ld    c, l
        ld    b, h
        ld    hl, imgData + 7
        ld    de, imgData + 15
        add   hl, bc
        ex    de, hl
        add   hl, bc
        ex    de, hl
        call  memcpy_D
        ld    hl, imgData + 3
        ld    a, (hl)
        set   3, (hl)
        xor   3
        ld    b, a
        ld    hl, 32
.l1:    add   hl, hl
        djnz  .l1
        ld    (imgData + 8), hl         ; W
        ld    hl, 240
        ld    (imgData + 10), hl        ; H
        ld    l, b
        ld    (imgData + 12), hl
        ret

decompressImg:
        ld    hl, imgData + 14
        ld    c, (hl)
        inc   hl
        ld    b, (hl)
        add   hl, bc
    if NO_INTERLACE == 0
        ld    de, 0bfffh
    else
        ld    de, 7fffh
    endif
        bit   4, (iy + 3)
        jr    nz, .l1
        push  hl                        ; RLE
        push  bc
        call  paletteSize
        pop   bc
        ld    a, c
        sub   l
        ld    c, a
        ld    a, b
        sbc   a, h
        ld    b, a
        pop   hl
        push  bc
.l1:    call  memcpy_D
        ld    l, e
        ld    h, d
        ld    de, imgData + 16
        inc   hl
        bit   4, (iy + 3)
        jr    z, .l3                    ; RLE?
        call  .l2
        ld    a, (imgData + 3)
        and   22h
        xor   20h
        ret   nz
.l2:    bit   2, (iy + 3)
        jp    nz, DecompressM0.decompressData
        jp    DecompressM2.decompressData
.l3:    push  hl
        call  paletteSize
        add   hl, de
        ld    e, l
        ld    d, h
        pop   hl
        pop   bc
        jp    decompressRLE

hiba:
        di
        call  irqCleanup
        ld    hl, 02d3h                 ; OUT (02H), A
        ld    (4000h), hl
        ld    a, 0e9h                   ; JP (HL)
        ld    (4002h), a
        xor   a
        ld    l, a
        ld    h, a
        jp    4000h

fileName:
        defb  10
        defm  "file01.kep"

imgData:

